
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Tenant_membershipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const tenant_memberships = await db.tenant_memberships.create(
            {
                id: data.id || undefined,
        
        is_owner: data.is_owner
        ||
        false
        
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        joined_at: data.joined_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await tenant_memberships.setTenant( data.tenant || null, {
            transaction,
        });
        
        await tenant_memberships.setUser( data.user || null, {
            transaction,
        });
        
        await tenant_memberships.setRole( data.role || null, {
            transaction,
        });
        
        await tenant_memberships.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        
        await tenant_memberships.setAllowed_locations(data.allowed_locations || [], {
            transaction,
        });
        

        

        return tenant_memberships;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const tenant_membershipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                is_owner: item.is_owner
            ||
            false
        
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                joined_at: item.joined_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const tenant_memberships = await db.tenant_memberships.bulkCreate(tenant_membershipsData, { transaction });

        // For each item created, replace relation files
        

        return tenant_memberships;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const tenant_memberships = await db.tenant_memberships.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.is_owner !== undefined) updatePayload.is_owner = data.is_owner;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.joined_at !== undefined) updatePayload.joined_at = data.joined_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await tenant_memberships.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await tenant_memberships.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await tenant_memberships.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.role !== undefined) {
            await tenant_memberships.setRole(
              
              data.role,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await tenant_memberships.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        
        if (data.allowed_locations !== undefined) {
            await tenant_memberships.setAllowed_locations(data.allowed_locations, { transaction });
        }
        

        

        return tenant_memberships;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const tenant_memberships = await db.tenant_memberships.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of tenant_memberships) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of tenant_memberships) {
                await record.destroy({transaction});
            }
        });


        return tenant_memberships;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const tenant_memberships = await db.tenant_memberships.findByPk(id, options);

        await tenant_memberships.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await tenant_memberships.destroy({
            transaction
        });

        return tenant_memberships;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const tenant_memberships = await db.tenant_memberships.findOne(
            { where },
            { transaction },
        );

        if (!tenant_memberships) {
            return tenant_memberships;
        }

        const output = tenant_memberships.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await tenant_memberships.getTenant({
            transaction
        });
        
        
        output.user = await tenant_memberships.getUser({
            transaction
        });
        
        
        output.role = await tenant_memberships.getRole({
            transaction
        });
        
        
        output.allowed_locations = await tenant_memberships.getAllowed_locations({
            transaction
        });
        
        
        output.organizations = await tenant_memberships.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              tenant_name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.roles,
        as: 'role',
        
        where: filter.role ? {
          [Op.or]: [
            { id: { [Op.in]: filter.role.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.role.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },


      {
        model: db.locations,
        as: 'allowed_locations',
        required: false,
      },


    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.joined_atRange) {
                const [start, end] = filter.joined_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_owner) {
                where = {
                    ...where,
                is_owner: filter.is_owner,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      


      if (filter.allowed_locations) {
        const searchTerms = filter.allowed_locations.split('|');

        include = [
          {
            model: db.locations,
            as: 'allowed_locations_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  location_name: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.tenant_memberships.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'tenant_memberships',
                        'is_owner',
                        query,
                    ),
                ],
            };
        }

        const records = await db.tenant_memberships.findAll({
            attributes: [ 'id', 'is_owner' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['is_owner', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.is_owner,
        }));
    }

    
};

